// LocalTalk.h
#include "CToast.h"
#include "ToastTalk.h"

TargetID			servTargetID;		// Include in UserRecord
AEAddressDesc		servAddressDesc;	// Ditto
char				*rcveBuffer,*sendBuffer;
long				gRcveBufferLength=4096L,gSendBufferLength=4096L;


ClientRec	clients[MAX_CLIENTS];
short		gNbrClients,gActiveClients;

ClientPtr	NewClient(long id, StringPtr name)
{
	ClientPtr	nc;
	if (gNbrClients < MAX_CLIENTS) {
		nc = &clients[gNbrClients++];
		nc->userID = id;
		BlockMove(name,nc->name,name[0]+1);
		ServerToClientEvent(nc,'ackr',id,NULL,0L);
		return nc;
	}
	else
		return NULL;
}

void DeactivateClient(long id)
{
	short	i;
	ClientPtr	nc;
	for (i = 0, nc = clients; i < gNbrClients; ++i,++nc) {
		if (nc->userID == id) {
			if (nc->active) {
				nc->active = false;
				gActiveClients--;
			}
		}
	}
}

void DeactivateClients()
{
	short	i;
	ClientPtr	nc;
	for (i = 0, nc = clients; i < gNbrClients; ++i,++nc) {
		if (nc->active) {
			nc->active = false;
			gActiveClients--;
		}
	}
}

void ActivateClients()
{
	short	i;
	ClientPtr	nc;
	for (i = 0, nc = clients; i < gNbrClients; ++i,++nc) {
		if (!nc->active) {
			nc->active = true;
			gActiveClients++;
		}
	}
}


// Server->Client
void ServerToClientEventLT(TargetID *destTargetID, unsigned long eventType, unsigned long refNum,
					Ptr bufferContents, long bufferLength)
{
	EventRecord	er;
	long		myOpts,myRID;
	OSErr		oe;

	er.what = kHighLevelEvent;
	er.message = ToastEventID;
	*((unsigned long *) &er.where) = eventType;
	myOpts = receiverIDisTargetID;
	myRID = (long) destTargetID;
	if (bufferLength) {
		if (bufferLength > gSendBufferLength) {
			gSendBufferLength = bufferLength+1024L;
			DisposePtr(sendBuffer);
			sendBuffer = NewPtrClear(gSendBufferLength);
			if (sendBuffer == NULL) {
				DebugStr("\pOut of Memory for Send");
				gSendBufferLength = 0L;
				return;
			}
		}
		BlockMove(bufferContents, sendBuffer, bufferLength);
	}
	oe = PostHighLevelEvent(&er, myRID, refNum, sendBuffer, bufferLength, myOpts);
}

// Client->Server
void ClientToServerEvent(unsigned long eventType, unsigned long refNum,
					Ptr bufferContents, long bufferLength)
{
	EventRecord	er;
	long		myOpts,myRID;
	OSErr		oe;

	if (gConnectionType != C_AppleTalk)
		return;

	er.what = kHighLevelEvent;
	er.message = ToastEventID;
	*((unsigned long *) &er.where) = eventType;
	myOpts = receiverIDisTargetID;
	myRID = (long) &servTargetID;
	if (bufferLength) {
		if (bufferLength > gSendBufferLength) {
			DisposePtr(sendBuffer);
			sendBuffer = NewPtrClear(bufferLength+1024L);
			if (sendBuffer == NULL) {
				sendBuffer = NewPtrClear(gSendBufferLength);
				if (sendBuffer == NULL)
					ExitToShell();
				return;
			}
			gSendBufferLength = bufferLength+1024;
		}
		BlockMove(bufferContents, sendBuffer, bufferLength);
	}
	oe = PostHighLevelEvent(&er, myRID, refNum, sendBuffer, bufferLength, myOpts);
}



// Server -> Client (Higher Level)
void ServerToClientEvent(ClientPtr	cp, unsigned long eventType,unsigned long refNum,Ptr bufferContents,long bufferLength)
{
	ServerToClientEventLT(&cp->networkID,eventType,refNum,bufferContents,bufferLength);
}

// Server->All Active Clients
void ServerToAllEvent(unsigned long eventType, unsigned long refNum,
					Ptr bufferContents, long bufferLength)
{
	short		n;
	ClientPtr	cp;
	for (n = 0,cp = clients; n < gNbrClients; ++n,++cp) {
		if (cp->active)
			ServerToClientEvent(cp, eventType,refNum,bufferContents,bufferLength);
	}
}


void InitAppleTalkBuffers()
{
	rcveBuffer = NewPtrClear(gRcveBufferLength);
	sendBuffer = NewPtrClear(gSendBufferLength);
}

void ProcessAppleTalkEvent(EventRecord *er)
{
	unsigned long	cmd;
	TargetID		tID;
	unsigned long	msgRefCon;
	unsigned long	msgLen;
	OSErr			oe;

	if (rcveBuffer == NULL)
		InitAppleTalkBuffers();

	cmd = (unsigned long) er->where.v;
	cmd <<= 16;
	cmd |= (unsigned long) er->where.h;

	// DebugMsg("BEG %.4s;g",&cmd);
	msgLen = gRcveBufferLength;
	oe = AcceptHighLevelEvent(&tID, &msgRefCon, rcveBuffer, &msgLen);
	if (oe == bufferIsSmall) {
		Ptr		newBuffer;
		long	prevLength,remLength;
		// SysBeep(1);
		prevLength = gRcveBufferLength;
		remLength = msgLen;
		newBuffer = NewPtrClear(gRcveBufferLength + msgLen + 1024L);
		if (newBuffer == NULL)
			return;
		BlockMove(rcveBuffer,newBuffer,prevLength);
		gRcveBufferLength += msgLen + 1024L;
		DisposePtr(rcveBuffer);
		rcveBuffer = newBuffer;
		oe = AcceptHighLevelEvent(&tID, &msgRefCon, rcveBuffer+prevLength, &msgLen);
		msgLen = prevLength + remLength;
	}
	// LogMessage("Msg In: <%.4s>\r",&cmd);
	if (oe == noErr) {
		// !! Note: need way to arbitrate additional users..
		if (cmd == 'regi') {
			ClientPtr	nc;
			nc = NewClient(tID.sessionID,(StringPtr) rcveBuffer);
			if (nc) {
				nc->connectionType = C_AppleTalk;
				nc->networkID = tID;
			}
			gConnectionType = C_AppleTalk;
			gClientMode = false;
			if (gGameState == GS_Play)
				SendSpriteList(nc);
		}
		else
			ProcessToastEvent(cmd, msgRefCon, rcveBuffer, msgLen);
	}
	// DebugMsg("END %.4s;g",&cmd);
}


pascal Boolean MyPortFilter(LocationNamePtr	theLoc, PortInfoPtr thePort)
{
	if (EqualString(thePort->name.name,"\pCT II",false,false) ||
		EqualString(thePort->name.name,"\pCToast || ",false,false))
		return true;
	else
		return false;
}

void SignOnAppleTalk()
{
	PortInfoRec		pRec;
	OSErr			oe = noErr;
	unsigned long	userRef;
	Str32			userName;
	PPCFilterUPP	filterProc = NewPPCFilterProc(MyPortFilter);

	if (rcveBuffer == NULL)
		InitAppleTalkBuffers();

	oe = PPCBrowser(NULL, NULL, false, &servTargetID.location, &pRec, filterProc, NULL);
	if (oe == noErr) {
		servTargetID.name = pRec.name;
		AECreateDesc(typeTargetID, &servTargetID, sizeof(servTargetID), &servAddressDesc);
		gConnectionType = C_AppleTalk;
		GetDefaultUser(&userRef,userName);
		// Put Username in Preferences (or get from Palace!)
		ClientToServerEvent('regi', userRef, (Ptr) userName, userName[0]+1);
	}
}
